#include <iostream>
#include <fstream>

#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "property_image.h"

#include "hough_transform2.h"
#include "canny.h"
using namespace mimas;
using namespace std;

int main( int argc, char **argv )
{
  int retVal = 0;
  try{
    x11_display display;
  
    image<unsigned char> edgeImage;
    image<rgba<unsigned char> > original;
  
    ////////Begin image pre-filtering/////////////////////////

    canny<unsigned char> canny;
  
    //canny.setCannyLowThres(20);
    //canny.setCannyHighThres(91);
    canny.setCannyAutoThres(true); // default is true anyway
    canny.setCannyStdDev(1);

    std::ifstream file( argv[1], ios::binary ); //should send an mimasexception if no filename is present
    //is it my job to do this or should it be embeded with ifstream or >> operator.
    
    file >> original;

    edgeImage = image< unsigned char >( original );

    canny.getEdges(edgeImage);

    image_mesaoutput< unsigned char > window( &display );
    window << edgeImage << mimas::pause();

    ///////////End of image pre-filtering////////////////////////

    //note how you can specify the size of the windows where to look for 
    //lines
    find_line<image<unsigned char>::iterator >
      h( edgeImage.ul() + dist2D(50,10),
	 edgeImage.lr() + dist2D(-10 ,0), atof(argv[2]) , atoi(argv[3]));
    
    window << h.exec() <<mimas::pause();
  } catch (exception &e) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

