#include <fstream>
#include <GL/glut.h>
#include "image_dc1394input.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;

// Minimal program for displaying multiple images from a single file.
int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    // Initialise GLUT.
    glutInit( &argc, argv );
    
    // Open X11 display.
    x11_display disp;

    // Load file.
    image_dc1394input< rgba< unsigned char > >
      input( MODE_640x480_YUV422, FRAMERATE_15 );
    
    // Open window.
    image_mesaoutput< rgba< unsigned char > > win( &disp );

    // Allocate image.
    image< rgba< unsigned char > > img;

    while( input ) {
      
      // Read image.
      input >> img;

      // Display image.
      win << img;

    };

  } catch ( exception &e ) {

    // Print error message.
    cerr << e.what() << endl;
    retVal = 1;

  };
  
  return retVal;
}
