#include "timer.h"

namespace mimas {

double timer::elapsed(std::string unit) const
{
#ifdef HAVE_GETTIMEOFDAY
  struct timeval actualTime;
  gettimeofday( &actualTime, NULL );

  // Use timersub-define, which does overflow-handling.
  struct timeval difference;
  timersub( &actualTime, &time, &difference );


  if (unit == std::string("s"))
    return difference.tv_sec + difference.tv_usec * 1.0E-6;
  if (unit == std::string("ms"))
    return difference.tv_sec * 1.0E3 + difference.tv_usec * 1.0E-3;
  if (unit == std::string("mms"))
    return difference.tv_sec * 1.0E6 + difference.tv_usec;
  
  //If we reach this point it means that the unit has been misspecified 
  assert(false);
  return -1;
#else
  assert( false );
  return 0;
#endif
}

}
